/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package testlongcommand;

import java.io.File;

/**
 *
 * @author Tim
 */
public class TestLongCommand {

    private final static String LONG_VALUE = "long.value";
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        final String longValue = System.getProperty(LONG_VALUE);
        if (longValue != null) {
            echoLongValue(longValue);
        } else if (args.length == 1) {
            /*
             * Create a new java command to run.
             */
            emitLongJavaCommand(args[0]);
        } else {
            throw new IllegalArgumentException("expected one arg or the property long.value but found neither");
        }
    }
    
    private static void emitLongJavaCommand(final String argLengthText) {
        final int argLength = Integer.parseInt(argLengthText);
//        System.err.println("count is " + argLength);
        final boolean isWindows = System.getProperty("os.name").contains("indows");
        final StringBuilder command = new StringBuilder();
        final File jreHome = new File(System.getProperty("java.home"));
        final File jreBin = new File(jreHome, "bin");
        final File java = new File(jreBin, "java" + (isWindows ? ".exe" : ""));
        
        final File jarFile = findLaunchedJAR();
        final String arg = longArgument(argLength);
        command.append(java).append(" ")
                .append("-javaagent:").append(jarFile.getAbsolutePath()).append('=').append(arg).append(' ')
                .append("-D").append(LONG_VALUE).append('=').append(arg).append(' ')
                .append("-jar ").append(jarFile.getAbsolutePath());
        
        System.out.println(command.toString());
        
        
    }
    
    
    private static String longArgument(final int argLength) {
        final StringBuilder sb = new StringBuilder();
        final char[] tens = {'A','B','C','D','E','F','G','H','I','_'};
        int charCount = 0;
        outerLoop:
        for (int hundreds = 0; charCount < argLength; hundreds += 100) {
            for (int t = 0; t < tens.length && charCount < argLength; t++) {
                for (int i = 1; i < 10 && charCount < argLength; i++) {
                    sb.append(i);
                    charCount++;
                }
                if (charCount < argLength) {
                    sb.append(tens[t]);
                    charCount++;
                }

            }
        }
        return sb.toString();
    }
    
    private static void echoLongValue(final String arg) {
        System.out.println(" Long value :" + arg);
    }
    
    private static File findLaunchedJAR() {
        try {
            return new File (TestLongCommand.class.getProtectionDomain().getCodeSource().getLocation().toURI());
        } catch (Exception ex) {
            throw new RuntimeException("Could not find launched JAR file", ex);
        }
    }
}
